﻿using UnityEngine;
using System.Collections;

public class ControlArma : MonoBehaviour {

	public Sprite bullet_1, bullet_2, bomba_1, bomba_2, melee_1, melee_2, laser_1, laser_2, casquillo_1, casquillo_2;

	public GameObject bullet, bomba_tiempo;
	public GameObject casquillo;
	public float retroceso;
	public int num_jugador;

	public int modo_disparo = 4;
	private bool disparando = false;

	private Ray2D ray;
	private RaycastHit2D hit;
	LineRenderer lineRenderer;
	public LayerMask layers;

	private GameObject camara;

	//este va a tener distintos tipos, dependiendo del tipo que este activado, es la imagen que muestra y el disparo que hace

	void Start(){

		lineRenderer = GetComponent<LineRenderer>();
		lineRenderer.SetVertexCount (2);
		lineRenderer.SetPosition (0, transform.position);
		lineRenderer.SetPosition (1, transform.position);
		lineRenderer.SetWidth (0.1f, 0.1f);
		//lineRenderer.material = new Material(Shader.Find("Particles/Additive"));

		if (num_jugador == 1) {

			
			camara = GameObject.Find ("Camera_P1");

				}

		if (num_jugador == 2) {

			camara = GameObject.Find ("Camera_P2");


				}
		
		modo_disparo = Random.Range(1,5);

		Asignar_Arma ();


		

	}

	public void Asignar_Arma(){

		if (num_jugador == 1) {

			switch(modo_disparo){
				
			case 1:
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;
				
			case 2:
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;
				
			case 3: 
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				break;
				
			case 4: 
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;
				
				
				
			}
		}
		if (num_jugador == 2) {

			switch(modo_disparo){

			case 1:
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;
			
			case 2:
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;

			case 3: 
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				break;

			case 4: 
				transform.FindChild("pistola").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("rasho").gameObject.GetComponent<SpriteRenderer>().enabled = false;
				transform.FindChild("melee").gameObject.GetComponent<SpriteRenderer>().enabled = true;
				break;
			
			
			
			}
		}

	}

	private void CambiarSprites(GameObject obj, Sprite nuevo_sprite){

		SpriteRenderer sr = obj.GetComponent<SpriteRenderer> ();
		sr.sprite = nuevo_sprite;

		}

	public void Disparar(Vector2 direccion, Vector2 pto_inicio){

		if (modo_disparo == 1) { //disparo de pistola;


						Shake s = camara.GetComponent<Shake> ();
						s.DoShake ();
			
						retroceso = 5f;
						rigidbody2D.velocity = new Vector2(rigidbody2D.velocity.x + (retroceso * GetComponent<Fisica_Jugador>().direccion_h * -1f), rigidbody2D.velocity.y);

						GameObject cas = Instantiate (casquillo, pto_inicio, Quaternion.identity) as GameObject;
						cas.GetComponent<Casquillo>().AsignarSprite(num_jugador);
						cas.rigidbody2D.velocity = new Vector2 (direccion.x * -2f, 10f);
						cas.rigidbody2D.AddTorque (10f);

						GameObject nuevo_bullet = Instantiate (bullet, pto_inicio, Quaternion.identity) as GameObject;

						if (num_jugador == 1)
								nuevo_bullet.gameObject.layer = 12;
						else
								nuevo_bullet.gameObject.layer = 13;

						Bullet b = nuevo_bullet.GetComponent<Bullet> ();
						b.direccion = direccion;

				}

		if (modo_disparo == 2) {//disparo de bomba

			if(!disparando){
			
			disparando = true;
			retroceso = 0f;
			GameObject bom = Instantiate(bomba_tiempo, pto_inicio, Quaternion.identity) as GameObject;

			transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = false;

			bom.GetComponent<Bomba_Tiempo>().jugador = num_jugador;
			bom.rigidbody2D.velocity = new Vector2 (direccion.x * 5f, 2f);
			bom.rigidbody2D.AddTorque (10f);
			bom.GetComponent<Bomba_Tiempo>().Detonar();

				Invoke ("Volver_a_poder_lanzar", 2f);
				}
				}

		if (modo_disparo == 3) { //disparo de rasho laser

			if(!disparando){
			disparando = true;
			retroceso = 10f;
			rigidbody2D.velocity = new Vector2(rigidbody2D.velocity.x + (retroceso * GetComponent<Fisica_Jugador>().direccion_h * -1f), rigidbody2D.velocity.y);
			StartCoroutine("Disparar_Rasho", direccion);
			}


				}

		if (modo_disparo == 4) { //melee island (?


			if (!disparando) {
							transform.FindChild("melee").Rotate(new Vector3(0f,0f,40f));
								disparando = true;
								retroceso = -5f;
								rigidbody2D.velocity = new Vector2 (rigidbody2D.velocity.x + (retroceso * GetComponent<Fisica_Jugador> ().direccion_h * -1f), rigidbody2D.velocity.y);
								for (int i = 0; i<12; i ++) {
				
										float dir = GetComponent<Fisica_Jugador> ().direccion_h;
										float x = transform.position.x + 0.5f * dir;
										float y = (transform.position.y - 0.5f) + (0.1f * i); 
				
										ray = new Ray2D (new Vector2 (x, y), new Vector2 (dir, 0));
				
										Debug.DrawRay (ray.origin, ray.direction * 1f);
				
										hit = Physics2D.Raycast (ray.origin, ray.direction, 1f, layers);

										if (hit) {

												if (hit.collider.gameObject.tag == "Player" || hit.collider.gameObject.tag == "Malo") {
						
														if (hit.collider.gameObject.tag == "Malo" && hit.collider.transform.parent) {
							
																Destroy (hit.collider.transform.parent.gameObject);

																if(num_jugador == 1) Jugador_Control.puntaje_1 += 1;
																if(num_jugador == 2) Jugador_Control.puntaje_2 += 1;
															
														}
						
														if (hit.collider.gameObject.tag == "Player") {
							
																if (hit.collider.gameObject.GetComponent<Jugador_Control> ().num_player == 1
																		&& hit.collider.gameObject.GetComponent<Fisica_Jugador> ().es_vulnerable) {
																		Destroy (hit.collider.gameObject);
																		Generador_Malos.murio_jugador_1 = true;
																		Jugador_Control.puntaje_2 -= 2;
																		
																}
																if (hit.collider.gameObject.GetComponent<Jugador_Control> ().num_player == 2
																		&& hit.collider.gameObject.GetComponent<Fisica_Jugador> ().es_vulnerable) {
																		Destroy (hit.collider.gameObject);
																		Generador_Malos.murio_jugador_2 = true;
																		Jugador_Control.puntaje_1 -= 2;
																}
							
														}
						
												}
										}

					

					

				
				
								}

				Invoke ("Puede_volver_a_pegar", 0.05f); ///pesima idea.. pero no se me ocurre otra.. D:

						}
				}
				
	}

	void Puede_volver_a_pegar(){

		disparando = false;
		transform.FindChild("melee").Rotate(new Vector3(0f,0f,-40f));

	}

	void Volver_a_poder_lanzar(){

		transform.FindChild("bomba").gameObject.GetComponent<SpriteRenderer>().enabled = true;
		disparando = false;

	}

	IEnumerator Disparar_Rasho(Vector2 direccion){


		lineRenderer.SetPosition (0, transform.position);
		lineRenderer.SetPosition (1, actualizarLargoBeam (direccion));
		yield return new WaitForSeconds (0.1f);

		for (int i = 0; i <= 10; i++) {

			if(i%2 == 0) lineRenderer.SetColors (Color.yellow, Color.red);
			else lineRenderer.SetColors (Color.red, Color.yellow);
			yield return new WaitForSeconds (0.01f);
			lineRenderer.SetPosition (0, transform.position);
			lineRenderer.SetPosition (1, actualizarLargoBeam (direccion));
		}

		lineRenderer.SetPosition (0, transform.position);
		lineRenderer.SetPosition (1, transform.position);
		yield return new WaitForSeconds (1f);
		disparando = false;

		}

	Vector3 actualizarLargoBeam(Vector2 direccion){
		

		ray = new Ray2D (transform.position, direccion);

		Debug.DrawRay(ray.origin,ray.direction * 80f);
		
		hit = Physics2D.Raycast (ray.origin, ray.direction, 80f, layers);
			
		if (hit.collider.gameObject.tag == "Player" || hit.collider.gameObject.tag == "Malo"){
					
					if (hit.collider.gameObject.tag == "Malo" && hit.collider.transform.parent) {
						
						Destroy(hit.collider.transform.parent.gameObject);

						if(num_jugador == 1) Jugador_Control.puntaje_1 += 1;
						if(num_jugador == 2) Jugador_Control.puntaje_2 += 1;
						
					}
					
					if (hit.collider.gameObject.tag == "Player") {
						
						if(hit.collider.gameObject.GetComponent<Jugador_Control>().num_player == 1
						   && hit.collider.gameObject.GetComponent<Fisica_Jugador>().es_vulnerable){
							Destroy(hit.collider.gameObject);
							Generador_Malos.murio_jugador_1 = true;
							Jugador_Control.puntaje_2 -= 2;
						}
						if(hit.collider.gameObject.GetComponent<Jugador_Control>().num_player == 2
						   && hit.collider.gameObject.GetComponent<Fisica_Jugador>().es_vulnerable){
							Destroy(hit.collider.gameObject);
							Generador_Malos.murio_jugador_2 = true;
							Jugador_Control.puntaje_1 -= 2;
						}
						
					}
			
		}

		return hit.point;
		
	}
}
