﻿using UnityEngine;
using System.Collections;

public class GeneradorNivel : MonoBehaviour {

	public int cantidadFilas;
	public int cantidadColumnas;
	public GameObject piso_1, piso_2;
	private Transform puntoInicial;
	private string[] nivel; 
	private int estilo_lvl = 0;
	public int cant_players = 2;
	private int num_nivel;

	public Sprite estilo_1_fondo_1, estilo_1_fondo_2, estilo_1_fondo_3,
	estilo_2_fondo_1, estilo_2_fondo_2, estilo_2_fondo_3, estilo_3_fondo_1, estilo_3_fondo_2, estilo_3_fondo_3;

	
	private int num_nivel_old;
	private int estilo_lvl_old;

	public Sprite sprite_1, sprite_2, sprite_3, sprite_4;
	
	// Use this for initialization
	void Start () {

		int i = Random.Range (1, 4);
		switch (i) {
		case 1: 
			
			GameObject.Find ("Fondo_1_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_1;
			GameObject.Find ("Fondo_1_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_1;
			GameObject.Find ("Fondo_2_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_2;
			GameObject.Find ("Fondo_2_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_2;
			GameObject.Find ("Fondo_3_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_3;
			GameObject.Find ("Fondo_3_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_1_fondo_3;
			break;
		case 2: 
			
			GameObject.Find ("Fondo_1_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_1;
			GameObject.Find ("Fondo_1_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_1;
			GameObject.Find ("Fondo_2_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_2;
			GameObject.Find ("Fondo_2_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_2;
			GameObject.Find ("Fondo_3_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_3;
			GameObject.Find ("Fondo_3_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_2_fondo_3;
			break;
		case 3:
			
			GameObject.Find ("Fondo_1_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_1;
			GameObject.Find ("Fondo_1_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_1;
			GameObject.Find ("Fondo_2_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_2;
			GameObject.Find ("Fondo_2_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_2;
			GameObject.Find ("Fondo_3_1").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_3;
			GameObject.Find ("Fondo_3_2").gameObject.GetComponent<SpriteRenderer>().sprite = estilo_3_fondo_3;
			break;
			
			
		}

		puntoInicial = GameObject.Find ("PuntoInicial").transform;
		nivel = new string[cantidadFilas];
		estilo_lvl_old = Random.Range (0, 4);
		num_nivel = Random.Range(1,6);

		Crear (piso_1);
		Crear (piso_2);

		}
	
	public void Crear(GameObject piso){

		switch (estilo_lvl_old) {

		case 0:	estilo_lvl = Random.Range (0,3); 
				estilo_lvl = (estilo_lvl == 0) ? 3 : estilo_lvl;
				break;
		case 1:	estilo_lvl = Random.Range (0,3); 
				estilo_lvl = (estilo_lvl == 1) ? 3 : estilo_lvl;
				break;
		case 2:	estilo_lvl = Random.Range (0,3); 
				estilo_lvl = (estilo_lvl == 2) ? 3 : estilo_lvl;
				break;
		case 3:	estilo_lvl = Random.Range (1,4); 
				estilo_lvl = (estilo_lvl == 3) ? 0 : estilo_lvl;
				break;

		}

		float x = puntoInicial.position.x;
		float y = puntoInicial.position.y;
		
		nivel = ElegirNivel ();

		for (int i = 0; i < cantidadFilas; i++) {
			for (int j = 0; j < cantidadColumnas; j++) {
				
				char a = nivel [i] [j];
				
				if (a.Equals ('A')) {
					GameObject piso_colocado = Instantiate (piso, new Vector3 (x + (j * piso.GetComponent<BoxCollider2D>().size.x * piso.transform.localScale.x), y - (i * piso.GetComponent<BoxCollider2D>().size.y * piso.transform.localScale.y), 0), Quaternion.identity) as GameObject;

					switch(estilo_lvl){

					case 0:
						piso_colocado.GetComponent<SpriteRenderer>().sprite = sprite_1;
						break;
					case 1:
						piso_colocado.GetComponent<SpriteRenderer>().sprite = sprite_2;
						break;
					case 2:
						piso_colocado.GetComponent<SpriteRenderer>().sprite = sprite_3;
						break;
					case 3:
						piso_colocado.GetComponent<SpriteRenderer>().sprite = sprite_4;
						break;

					}

				}
					
				}
				
			}

		estilo_lvl_old = estilo_lvl;
		
		
	}
	
	
	private string[] ElegirNivel (){

		string[] nivel_elegido = new string[cantidadFilas];

		switch (num_nivel) {

		case 1:

			nivel_elegido[0] = 	"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			nivel_elegido[1] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[2] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[3] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[4] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[5] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[6] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[7] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[8] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[9] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[10] = "A0000000000000000000000000000000000A";
			nivel_elegido[11] = "A0000000000000000000000000000000000A";
			nivel_elegido[12] = "A0000000000000000000000000000000000A";
			nivel_elegido[13] = "A0000000000000000000000000000000000A";
			nivel_elegido[14] = "A0000000000000AAAAAAAA0000000000000A";
			nivel_elegido[15] = "A0000000AAAA000000000000AAAA0000000A";
			nivel_elegido[16] = "A00AAA000000000000000000000000AAA00A";
			nivel_elegido[17] = "A0000000000000000000000000000000000A";
			nivel_elegido[18] = "A0000000000000000000000000000000000A";
			nivel_elegido[19] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
            break;

		case 2:

			nivel_elegido[0] = 	"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			nivel_elegido[1] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[2] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[3] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[4] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[5] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[6] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[7] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[8] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[9] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[10] = "A0000000000000000000000000000000000A";
			nivel_elegido[11] = "A0000000000000000000000000000000000A";
			nivel_elegido[12] = "A0000000000000000000000000000000000A";
			nivel_elegido[13] = "A0000000000000000000000000000000000A";
			nivel_elegido[14] = "A0000000000000000000000000000000000A";
			nivel_elegido[15] = "A0000000000000000000000000000000000A";
			nivel_elegido[16] = "A00000000000000AAAAAA00000000000000A";
			nivel_elegido[17] = "AAAAAA0000AA0000000000000AA0000AAAAA";
			nivel_elegido[18] = "A0000000000000000000000000000000000A";
			nivel_elegido[19] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			break;

		case 3:
			
			nivel_elegido[0] = 	"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			nivel_elegido[1] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[2] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[3] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[4] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[5] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[6] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[7] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[8] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[9] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[10] = "A0000000000000000000000000000000000A";
			nivel_elegido[11] = "A0000000000000000000000000000000000A";
			nivel_elegido[12] = "A0000000000000000000000000000000000A";
			nivel_elegido[13] = "A0000000000000000000000000000000000A";
			nivel_elegido[14] = "A000000000000AAAAAAAAA0000000000000A";
			nivel_elegido[15] = "A0000000000000000000000000000000000A";
			nivel_elegido[16] = "A0000000000AA0000000000AA0000000000A";
			nivel_elegido[17] = "A0000AAAA000000000000000000AAAA0000A";
			nivel_elegido[18] = "A0000000000000000000000000000000000A";
			nivel_elegido[19] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			break;

		case 4:
			
			nivel_elegido[0] = 	"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			nivel_elegido[1] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[2] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[3] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[4] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[5] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[6] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[7] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[8] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[9] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[10] = "A0000000000000000000000000000000000A";
			nivel_elegido[11] = "A0000000000000000000000000000000000A";
			nivel_elegido[12] = "A0000000000000000000000000000000000A";
			nivel_elegido[13] = "A0000000000000000000000000000000000A";
			nivel_elegido[14] = "A0000000000000000000000000000000000A";
			nivel_elegido[15] = "A000AAAA00000000000000000000AAAA000A";
			nivel_elegido[16] = "A00000000000000AAAAAA00000000000000A";
			nivel_elegido[17] = "AAA000000000000000000000000000000AAA";
			nivel_elegido[18] = "A0000000000000000000000000000000000A";
			nivel_elegido[19] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			break;

		case 5:
			
			nivel_elegido[0] = 	"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			nivel_elegido[1] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[2] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[3] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[4] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[5] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[6] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[7] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[8] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[9] = 	"A0000000000000000000000000000000000A";
			nivel_elegido[10] = "A0000000000000000000000000000000000A";
			nivel_elegido[11] = "A0000000000000000000000000000000000A";
			nivel_elegido[12] = "A000AAAA00000000000000000000AAAA000A";
			nivel_elegido[13] = "A0000000000000000000000000000000000A";
			nivel_elegido[14] = "AA00000000000000000000000000000000AA";
			nivel_elegido[15] = "A0000000000000000000000000000000000A";
			nivel_elegido[16] = "A000AA000000000000000000000000AA000A";
			nivel_elegido[17] = "A00000000AAAA0000000000AAAA00000000A";
			nivel_elegido[18] = "A0000000000000000000000000000000000A";
			nivel_elegido[19] = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA";
			break;

				}

		return nivel_elegido;
		
		
	}
}
