﻿using UnityEngine;
using System.Collections;

public class Malos : MonoBehaviour {

	Fisica_Jugador fisica1,fisica2;
	ControlArma arma1,arma2;
	Jugador_Control jugador1, jugador2;
	bool sigue_a_jugador;
	GameObject target;
	bool saltando;

	// Use this for initialization
	void Start () {

		fisica1 = transform.FindChild("Malo1").gameObject.GetComponent<Fisica_Jugador> ();
		fisica2 = transform.FindChild("Malo2").gameObject.GetComponent<Fisica_Jugador> ();
		arma1 = transform.FindChild("Malo1").gameObject.GetComponent<ControlArma> ();
		arma2 = transform.FindChild("Malo2").gameObject.GetComponent<ControlArma> ();
		jugador1 = transform.FindChild("Malo1").gameObject.GetComponent<Jugador_Control> ();
		jugador2 = transform.FindChild("Malo2").gameObject.GetComponent<Jugador_Control> ();

		InvokeRepeating ("CambiarSeguimiento", 0f, 2.5f);

	}

	void CambiarSeguimiento(){

		int i = Random.Range (0, 2);
		sigue_a_jugador = (i == 0) ? true : false;

		if(sigue_a_jugador)
		Invoke ("DejarSeguimiento", 1f);



	}

	void DejarSeguimiento(){

		sigue_a_jugador = false;
		target = null;

	}


	// Update is called once per frame
	void Update () {

		if (!sigue_a_jugador) {

					if (fisica1.colision_a_derecha) {
								jugador1.input_x = -1f;
								jugador2.input_x = -1f;
						} else {
								jugador1.input_x = 1f;
								jugador2.input_x = 1f;
						}
				} else {

			if(!target){

				AsignarTarget();

				} else {

				jugador1.input_x = target.GetComponent<Jugador_Control>().input_x;
				jugador2.input_x = target.GetComponent<Jugador_Control>().input_x;

				jugador1.input_salto = target.GetComponent<Jugador_Control>().input_salto;
				jugador2.input_salto = target.GetComponent<Jugador_Control>().input_salto;


			}

				}

	}

	void AsignarTarget(){

		int i = Random.Range (0, 2);

		if (i == 0){

				if (GameObject.Find ("Jugador1"))
				target = GameObject.Find ("Jugador1");

				} else {

				if(GameObject.Find("Jugador2"))
				target = GameObject.Find("Jugador2");

				}

		if (!saltando) {
			float j = Random.Range (1f, 2f);
			Invoke ("Saltar", j);
		}

		}

	void Saltar(){

		saltando = true;
		jugador1.input_salto = true;
		jugador2.input_salto = true;

		StartCoroutine ("Dejar_Salto");


	}

	IEnumerator Dejar_Salto(){

		yield return new WaitForSeconds (0.01f);

		saltando = false;
		jugador1.input_salto = false;
		jugador2.input_salto = false;

	}
}
