﻿using UnityEngine;
using System.Collections;

public class Seguimiento_Camara : MonoBehaviour {

	public GameObject fondo_1, fondo_2, fondo_3;
	public Transform target;
	public float vel;

	public bool camara;

	private Vector2 posicion_inicial_camara;
	private float offset = 20f;
	
	public void setTarget(Transform target){
		
		this.target = target;
		
	}

	void Start(){

		posicion_inicial_camara = transform.position;

		}

	void LateUpdate () {
			

		if (target) {
						float x = 0f;
						float y = 0f;
			
						x = dirigirse_a_target (transform.position.x, target.position.x, vel);
						y = dirigirse_a_target (transform.position.y, target.position.y, vel);
			
						transform.position = new Vector3 (x, y, transform.position.z);

			if(camara){
						fondo_1.transform.position = new Vector2((fondo_1.transform.position.x - posicion_inicial_camara.x) / offset, (fondo_1.transform.position.y + posicion_inicial_camara.y) / offset); 
						fondo_1.transform.position = new Vector2((fondo_1.transform.position.x - posicion_inicial_camara.x) / offset * 0.5f, (fondo_1.transform.position.y + posicion_inicial_camara.y) / offset * 0.5f);
						fondo_1.transform.position = new Vector2((fondo_1.transform.position.x - posicion_inicial_camara.x) / offset * 0.25f, (fondo_1.transform.position.y + posicion_inicial_camara.y) / offset * 0.25f);
			}
		}
		}
	
	private float dirigirse_a_target(float n, float target, float a) {
		if (n == target) {
			return n;	
		}
		else {
			float dir = Mathf.Sign(target - n); 
			n += a * Time.deltaTime * dir;
			return (dir == Mathf.Sign(target-n))? n: target; 
		}
	}
}
